#include "SimpleModbusSlave.h"
#include <Servo.h> 

Servo myservo3, myservo5, myservo6, myservo9, myservo10, myservo11;

#define HOLDING_REGS_SIZE 20

enum
{
  PWM3_VAL,
  PWM5_VAL,
  PWM6_VAL,
  PWM9_VAL,
  PWM10_VAL,
  PWM11_VAL,
  ADC0_VAL,
  ADC1_VAL,
  ADC2_VAL,
  ADC3_VAL,
  ADC4_VAL,
  ADC5_VAL,
};

unsigned int holdingRegs[HOLDING_REGS_SIZE]; // function 3 and 16 register array
////////////////////////////////////////////////////////////

void setup()
{
  modbus_configure(&Serial, 9600, SERIAL_8N1, 1, 2, HOLDING_REGS_SIZE, holdingRegs);    
  myservo3.attach(3);
  myservo5.attach(5);
  myservo6.attach(6);
  myservo9.attach(9);
  myservo10.attach(10);
  myservo11.attach(11);
}

void loop()
{
  modbus_update();
  // read anlog inputs
  holdingRegs[ADC0_VAL] = analogRead(A0); // update data to be read by the master to adjust the PWM
  holdingRegs[ADC1_VAL] = analogRead(A1); // update data to be read by the master to adjust the PWM
  holdingRegs[ADC2_VAL] = analogRead(A2); // update data to be read by the master to adjust the PWM
  holdingRegs[ADC3_VAL] = analogRead(A3); // update data to be read by the master to adjust the PWM
  holdingRegs[ADC4_VAL] = analogRead(A4); // update data to be read by the master to adjust the PWM
  holdingRegs[ADC5_VAL] = analogRead(A5); // update data to be read by the master to adjust the PWM
  // Write analog outputs
  myservo3.write(holdingRegs[PWM3_VAL]); 
  myservo5.write(holdingRegs[PWM5_VAL]); 
  myservo6.write(holdingRegs[PWM6_VAL]); 
  myservo9.write(holdingRegs[PWM9_VAL]); 
  myservo10.write(holdingRegs[PWM10_VAL]); 
  myservo11.write(holdingRegs[PWM11_VAL]); 
}
